#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "Fish_GiantSharkCardReward.h"
std::auto_ptr<Fish_GiantSharkCardReward> Fish_GiantSharkCardReward::msSingleton(nullptr);

int Fish_GiantSharkCardReward::GetCount()
{
	return (int)mMapData.size();
}

const Fish_GiantSharkCardRewardData* Fish_GiantSharkCardReward::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, Fish_GiantSharkCardRewardData>& Fish_GiantSharkCardReward::GetMapData()
{
	return mMapData;
}

void Fish_GiantSharkCardReward::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/Fish_GiantSharkCardReward.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_GiantSharkCardRewardData data;
		data.mID = element->IntAttribute("ID");
		data.mKeyType = element->IntAttribute("KeyType");
		data.mMinGold = element->IntAttribute("MinGold");
		data.mMaxGold = element->IntAttribute("MaxGold");
		data.mWeight = element->IntAttribute("Weight");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("Fish_GiantSharkCardReward Loaded. Load Data:%u", mMapData.size());
}

void Fish_GiantSharkCardReward::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/Fish_GiantSharkCardReward");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "Fish_GiantSharkCardReward");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		Fish_GiantSharkCardRewardData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readInt(L, "KeyType", data.mKeyType);
		LuaCfgHelper::readInt(L, "MinGold", data.mMinGold);
		LuaCfgHelper::readInt(L, "MaxGold", data.mMaxGold);
		LuaCfgHelper::readInt(L, "Weight", data.mWeight);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("Fish_GiantSharkCardReward Loaded. Load Data:%u", mMapData.size());
}

void Fish_GiantSharkCardReward::Reload()
{
	mMapData.clear();
	Load();
}

Fish_GiantSharkCardReward* Fish_GiantSharkCardReward::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_GiantSharkCardReward());
	}
	return msSingleton.get();
}

void Fish_GiantSharkCardReward::Release()
{
	msSingleton.reset(nullptr);
}
